﻿using System;
using System.Collections.Generic;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

using XNAExtras;

namespace BitmapFontDemo
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class BitmapFontdemo : Microsoft.Xna.Framework.Game
    {
		public static BitmapFont m_fontTimes;
		public static BitmapFont m_fontComic;
		public static BitmapFont m_fontRussian;
		public static BitmapFont m_fontJapanese;

        GraphicsDeviceManager graphics;
		
		public BitmapFontdemo()
        {
            graphics = new GraphicsDeviceManager(this);
        }

        protected override void Initialize()
		{
			graphics.GraphicsDevice.DeviceReset += new EventHandler(GraphicsDevice_DeviceReset);

			m_fontTimes = new BitmapFont("times.xml");
			m_fontComic = new BitmapFont("comic.xml");
			m_fontRussian = new BitmapFont("russian.xml");
			m_fontJapanese = new BitmapFont("japanese.xml");

			LoadResources();
		}

		void GraphicsDevice_DeviceReset(object sender, EventArgs e)
		{
			LoadResources();
		}

		void LoadResources()
		{
			m_fontTimes.Reset(graphics.GraphicsDevice);
			m_fontComic.Reset(graphics.GraphicsDevice);
			m_fontRussian.Reset(graphics.GraphicsDevice);
			m_fontJapanese.Reset(graphics.GraphicsDevice);
		}

		protected override void Update(GameTime gameTime)
        {
            // The time since Update was called last
            float elapsed = (float)gameTime.TotalRealTime.Seconds;

            // TODO: Add your game logic here
        }

        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
			Color cHilite = Color.DarkBlue;
			Color cWhite = Color.White;

			int nX = 20;
			int nY = -15;
			int nWidth;

			// custom glyph font test
			nY += 20;
			m_fontComic.DrawString(nX, nY += m_fontComic.LineHeight, cWhite, "Press the q button to switch weapons");

			// kerning test
			nY += 20;
			m_fontTimes.KernEnable = false;
			nWidth = m_fontTimes.MeasureString("WATER");
			m_fontTimes.DrawString(nX, nY += m_fontTimes.LineHeight, "WATER (kerning off = {0} pixels)", nWidth);
			m_fontTimes.KernEnable = true;
			nWidth = m_fontTimes.MeasureString("WATER");
			m_fontTimes.DrawString(nX, nY += m_fontTimes.LineHeight, "WATER (kerning on = {0} pixels)", nWidth);

			// russian font test
			nY += 20;
			m_fontRussian.DrawString(nX, nY += m_fontRussian.LineHeight, cWhite, "Спасибо Вам за то, что Вы спасли мне жизнь!");

			// japanese font test
			nY += 20;
			m_fontJapanese.TextColor = cWhite;
			m_fontJapanese.DrawString(nX, nY += m_fontJapanese.LineHeight, "That will cost 450 gold yippits.");
			m_fontJapanese.DrawString(nX, nY += m_fontJapanese.LineHeight, "お兄ちゃ…　お兄ちゃんなんか大っ嫌い！");
			// japanese font - using previous pen, changing color
			m_fontJapanese.SetPen(nX, nY += m_fontJapanese.LineHeight);
			m_fontJapanese.DrawString(cWhite, "豚みたいな獣が");
			m_fontJapanese.DrawString(cHilite, "ボクの剣");
			m_fontJapanese.DrawString(cWhite, "を");
			m_fontJapanese.DrawString("食った。");


            graphics.GraphicsDevice.Present();
        }
    }
}
